package com.yihu.wlyy.logs;

import org.json.JSONArray;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 业务日志输出
 * <p>
 * Created by lyr-pc on 2017/1/19.
 */
public class BusinessLogs {

    // 日志输出
    private static Logger logger = LoggerFactory.getLogger(BusinessLogs.class);

    /**
     * 业务类型
     */
    public enum BusinessType {
        // 咨询
        consult
        // 指导
        , guidance
        // 健康教育
        , article
        // 随访
        , followup
        // 预约
        , appointment
        // 标签
        , label
        // 签约
        , register
    }

    /**
     * 业务日志输出
     *
     * @param type 业务类别
     * @param info 日志信息
     */
    public static void info(BusinessType type, String user, JSONObject info) {
        try {
            logger.info(type.ordinal() + " - " + user + " - " + info.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 业务日志输出
     *
     * @param type 业务类别
     * @param info 日志信息
     */
    public static void info(BusinessType type, String user, JSONArray info) {
        try {
            logger.info(type.ordinal() + " - " + user + " - " + info.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
